require 'httparty'

module Recomiendo
  class Client
    include HTTParty
    base_uri 'https://recomien.do/api'
    ssl_version :SSLv3
    headers 'Accept' => 'application/vnd.recomiendo.v1'
    

    def initialize(key, secret)
      @auth = { username: key, password: secret }
    end

    def post(path, params)
      self.class.post(path, body: params, basic_auth: @auth)
    end

    def get(path, params)
      self.class.get(path, query: params, basic_auth: @auth)
    end
    
    def delete(path)
      self.class.delete(path, basic_auth: @auth)
    end
    
    def put(path, params)
      self.class.put(path, body: params, basic_auth: @auth)
    end

    def accounts
      Recomiendo::Account.new(self)
    end

    def links
      Recomiendo::Link.new(self)
    end

    def rewards
      Recomiendo::Reward.new(self)
    end
  end
end